//+------------------------------------------------------------------+
//|                                                 HSTconverter.mq4 |
//|                                      Copyright 2016, GoldenMoney |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, GoldenMoney"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property show_inputs

enum Select
{
  All_Symbols_All_Timeframes,
  All_Symbols_Only_M1,
  All_Symbols_Only_M5,
  All_Symbols_Only_M15,
  All_Symbols_Only_M30,
  All_Symbols_Only_H1,
  All_Symbols_Only_H4,
  All_Symbols_Only_D1,
  All_Symbols_Only_W1,
  All_Symbols_Only_MN1,
  Custom_Symbols_Timeframes
};

enum Delimiter
{
  comma,
  semicolon
};

extern bool FileInHistory = true;
extern Select Choice = All_Symbols_Only_D1;
extern string set = "-------"; // If custom -> choice TF and Symbols
extern string customTF = "M1,M5,M15,M30,H1,H4,D1,W1,MN1";
extern string customSymbols = "EURUSD,USDJPY,GBPUSD,AUDUSD,USDCHF,USDCAD,NZDUSD,EURJPY,EURGBP";
extern Delimiter CSVDelimiter = comma;

string tf[] = {"1","5","15","30","60","240","1440","10080","43200"}; //8
//extern string input_file_name = "EURUSD.ecn1440.hst";
string tf_custom[];
string symbol_custom[];

int hst_handle;
int err;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   string SymbolsList[];

   //get all symbols
   SymbolsList(SymbolsList, false); 
   
   switch (Choice)
   {
     case All_Symbols_All_Timeframes:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {
         for (int j = 0; j <=8; j++)
         {
           RunConverter(SymbolsList[i]+tf[j]+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
         }
       } 
     }
     break;
     
     case All_Symbols_Only_M1:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"1"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_M5:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"5"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_M15:
     {
      for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"15"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_M30:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"30"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_H1:
     {
      for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"60"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_H4:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"240"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_D1:
     {
      for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"1440"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       }     
     }
     break;
     
     case All_Symbols_Only_W1:
     {
       for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"10080"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case All_Symbols_Only_MN1:
     {
      for (int i = 0; i <= ArraySize(SymbolsList) - 1; i++)
       {        
         RunConverter(SymbolsList[i]+"43200"+".hst",(int)MarketInfo(SymbolsList[i],MODE_DIGITS));
       } 
     }
     break;
     
     case Custom_Symbols_Timeframes:
     {
      loadCustomSymbols(customSymbols);
      loadCustomTF(customTF);
      
      for (int i = 0; i <= ArraySize(symbol_custom) - 1; i++)
       {
         for (int j = 0; j <= ArraySize(tf_custom) - 1; j++)
         {
           RunConverter(symbol_custom[i]+tf_custom[j]+".hst",(int)MarketInfo(symbol_custom[i],MODE_DIGITS));
         }
       } 
     }
     break;
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RunConverter(string input_file_name, int _digits)
{
  // open input file
	if (FileInHistory)
		hst_handle = FileOpenHistory(input_file_name, FILE_BIN | FILE_READ | FILE_SHARE_READ);
	else
		hst_handle = FileOpen(input_file_name, FILE_BIN | FILE_READ | FILE_SHARE_READ);

	if (hst_handle == INVALID_HANDLE)
	{
	   //Print(input_file_name + "not exist");
	   return;
	}

	// read header hst	
	FileSeek(hst_handle, 0, SEEK_SET);
   int format = FileReadInteger(hst_handle, LONG_VALUE); // format hst 400/401
   

	FileSeek(hst_handle, 68, SEEK_SET); // 68b leave

	string hst_symbol = FileReadString(hst_handle, 12);
	int hst_period = FileReadInteger(hst_handle, LONG_VALUE);
	
	
	// open output file
	string csv_file_name = StringConcatenate(hst_symbol, hst_period, ".csv");
   
   char delimiter = ',';
   if (CSVDelimiter == semicolon)
     delimiter = ';';
     
	int csv_handle = FileOpen(csv_file_name, FILE_CSV | FILE_WRITE, delimiter);

	if (csv_handle == INVALID_HANDLE)
	{
		err = GetLastError();
		Print("Can't open file *.csv ", err);
	}
   if (format == 401)
   {
	  FileWrite(csv_handle, "Date", "Time", "Open", "High", "Low", "Close", "Volume", "Spread", "Real Volume");
   }
   if (format == 400)
   {
     FileWrite(csv_handle, "Date", "Time", "Open", "Low", "High", "Close", "Volume");
   }
   
	err = GetLastError();
	if (err > 0)
	{
		err = GetLastError();
		Print("Error write data to.*csv ", err);
	}
	

	// read data from hst // 401/400
	FileSeek(hst_handle, 148, SEEK_SET);
	
	if (format == 401)
	{
	while (!FileIsEnding(hst_handle))
	{
		int bar_time = FileReadInteger(hst_handle, LONG_VALUE);
		FileSeek(hst_handle, 4, SEEK_CUR);
		double bar_open = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double bar_high = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double bar_low = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double bar_close = FileReadDouble(hst_handle, DOUBLE_VALUE);
		long volume = FileReadLong(hst_handle);                        // 8 b
		int spread = FileReadInteger(hst_handle, LONG_VALUE);          // 4 b
		long real_volume = FileReadLong(hst_handle);                   // 8 b
		
		//FileSeek(hst_handle, 20, SEEK_CUR); // leave spread/real volume

		err = GetLastError();
		if (err == 4099)
			break;

		string bar_time_date = TimeToStr(bar_time, TIME_DATE);
		string bar_time_min  = 	TimeToStr(bar_time, TIME_MINUTES);

		// write to csv
		FileWrite(csv_handle, bar_time_date, bar_time_min, DoubleToString(bar_open,_digits), DoubleToString(bar_high,_digits), DoubleToString(bar_low,_digits), DoubleToString(bar_close,_digits), volume, spread, real_volume);

		err = GetLastError();
	   if (err > 0)
	   {
		   err = GetLastError();
		   Print("Error write data to.*csv ", err);
	   }
	}
	FileClose(hst_handle);
	FileClose(csv_handle);
	
	Print("<Terminal folder>\\MQ4\\Files\\" + csv_file_name, " created ok");
	}
	//---
	if (format == 400)
	{
	while (!FileIsEnding(hst_handle))
	{
		int bar_time = FileReadInteger(hst_handle, LONG_VALUE);
		double bar_open = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double bar_low = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double bar_high = FileReadDouble(hst_handle, DOUBLE_VALUE);		
		double bar_close = FileReadDouble(hst_handle, DOUBLE_VALUE);
		double volume = FileReadDouble(hst_handle, DOUBLE_VALUE);                        // 8 b

		err = GetLastError();
		if (err == 4099)
			break;

		string bar_time_date = TimeToStr(bar_time, TIME_DATE);
		string bar_time_min  = 	TimeToStr(bar_time, TIME_MINUTES);

		// write to csv
		FileWrite(csv_handle, bar_time_date, bar_time_min, bar_open, bar_low, bar_high, bar_close, volume);

		err = GetLastError();
	   if (err > 0)
	   {
		   err = GetLastError();
		   Print("Error write data to.*csv ", err);
	   }
	}
	FileClose(hst_handle);
	FileClose(csv_handle);
	
	Print("<Terminal folder>\\MQ4\\Files\\" + csv_file_name, " created ok");
	}
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SymbolsList(string &Symbols[], bool Selected)
{
   string SymbolsFileName;
   int Offset, SymbolsNumber;
  
   if(Selected) SymbolsFileName = "symbols.sel";
   else         SymbolsFileName = "symbols.raw";
  
   // open file symbols

   int hFile = FileOpenHistory(SymbolsFileName, FILE_BIN|FILE_READ);
   if(hFile < 0) return(-1);

   // define count symbols

   if(Selected) { SymbolsNumber = int((FileSize(hFile) - 4) / 128); Offset = 116;  }
   else         { SymbolsNumber = int(FileSize(hFile) / 1936);      Offset = 1924; }

   ArrayResize(Symbols, SymbolsNumber);

   // read symbols from file

   if(Selected) FileSeek(hFile, 4, SEEK_SET);
  
   for(int i = 0; i < SymbolsNumber; i++)
   {
      Symbols[i] = FileReadString(hFile, 12);
      FileSeek(hFile, Offset, SEEK_CUR);
   }
  
   FileClose(hFile);
  
   // return count of symbols

   return(SymbolsNumber);
}
//---
#define sectorSize  1936
#define HFILE_ERROR -1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void getPrefixSuffix(string& prefix, string& suffix)
{
   int fileHandle = FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ);
   if (fileHandle == HFILE_ERROR) return;
   prefix=""; suffix="";
   for(int i=0;; i++)
   {
      FileSeek(fileHandle, sectorSize*i, SEEK_SET); 
      if (FileIsEnding(fileHandle)) 
      { 
      prefix="err"; 
      break; 
      }
      string symbolName = FileReadString(fileHandle,12);
      symbolName = StringSubstr(symbolName, 0);
      int pos = StringFind(symbolName,"EURUSD",0);
      if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }   
   }
   if (fileHandle>-1) FileClose(fileHandle);
}  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool loadCustomSymbols(string in_string)
  {
   int num = 0;
   string p = "";
   string s = "";
   // get prefix / suffix for symbol
   getPrefixSuffix(p,s);
   
   string work_string = in_string + ",";
   while(true)
     {
      int pos = StringFind(work_string, ",", 0);
      if(pos >= 0)
        {
         ArrayResize(symbol_custom,num+1);         
         symbol_custom[num]=p + StringSubstr(work_string,0,pos) + s;
         work_string=StringSubstr(work_string,pos+1);
         num++;
        }
      else
         break;
     }
     return (true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool loadCustomTF(string in_string)
  {
   int num = 0;
   string work_string = in_string + ",";
   while(true)
     {
      int pos = StringFind(work_string, ",", 0);
      if(pos >= 0)
        {
         ArrayResize(tf_custom,num+1);
         tf_custom[num]= GetMinuteTF(StringSubstr(work_string,0,pos));
         work_string=StringSubstr(work_string,pos+1);
         num++;
        }
      else
         break;
     }
     return (true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetMinuteTF(string value) 
{
  if (value == "M1")
    return(tf[0]);
  if (value == "M5")
    return(tf[1]);
  if (value == "M15")
    return(tf[2]);
  if (value == "M30")
    return(tf[3]);
  if (value == "H1")
    return(tf[4]);
  if (value == "H4")
    return(tf[5]);
  if (value == "D1")
    return(tf[6]);
  if (value == "W1")
    return(tf[7]);
  if (value == "MN1")
    return(tf[8]);
  return(NULL);
}
//+------------------------------------------------------------------+
